/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.configuracioneccomerciales;

import java.util.HashMap;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Paging;
import org.zkoss.zul.Textbox;

import com.rjconsultores.ventaboletos.entidad.MotivoDevolucaoBilhete;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderMotivoDevolucaoBilhete;

/**
 *
 * @author Bruno Neves
 */
@Controller("busquedaMotivoDevolucaoBilheteController")
@Scope("prototype")
public class BusquedaMotivoDevolucaoBilheteController extends MyGenericForwardComposer {

    @Autowired
    private transient PagedListWrapper<MotivoDevolucaoBilhete> plwMotivoDevolucaoBilhete;
    private MyListbox motivoDevolucaoBilheteList;
    private Paging pagingMotivoDevolucaoBilhete;
    private Textbox txtNombre;
    private Combobox cmbTipoMotivo;

    public Combobox getCmbTipoMotivo() {
        return cmbTipoMotivo;
    }

    public void setCmbTipoMotivo(Combobox cmbTipoMotivo) {
        this.cmbTipoMotivo = cmbTipoMotivo;
    }

    public Paging getPagingMotivoDevolucaoBilhete() {
        return pagingMotivoDevolucaoBilhete;
    }

    public void setPagingMotivoDevolucaoBilhete(Paging pagingMotivoDevolucaoBilhete) {
        this.pagingMotivoDevolucaoBilhete = pagingMotivoDevolucaoBilhete;
    }

    public MyListbox getMotivoDevolucaoBilheteList() {
        return motivoDevolucaoBilheteList;
    }

    public void setMotivoDevolucaoBilheteList(MyListbox motivoDevolucaoBilheteList) {
        this.motivoDevolucaoBilheteList = motivoDevolucaoBilheteList;
    }

    public PagedListWrapper<MotivoDevolucaoBilhete> getPlwMotivoDevolucaoBilhete() {
        return plwMotivoDevolucaoBilhete;
    }

    public void setPlwMotivoDevolucaoBilhete(PagedListWrapper<MotivoDevolucaoBilhete> plwMotivoDevolucaoBilhete) {
        this.plwMotivoDevolucaoBilhete = plwMotivoDevolucaoBilhete;
    }

    public void onClick$btnPesquisa(Event ev) throws InterruptedException {
        refreshLista();
    }

    public void onClick$btnRefresh(Event ev) {
        refreshLista();
    }

    public void onClick$btnNovo(Event ev) {
        verPeriodo(new MotivoDevolucaoBilhete());
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        super.doAfterCompose(comp);

        motivoDevolucaoBilheteList.setItemRenderer(new RenderMotivoDevolucaoBilhete());
        motivoDevolucaoBilheteList.addEventListener("onDoubleClick", new EventListener() {

            @Override
            public void onEvent(Event event) throws Exception {
                MotivoDevolucaoBilhete mc = (MotivoDevolucaoBilhete) motivoDevolucaoBilheteList.getSelected();
                verPeriodo(mc);
            }
        });

        refreshLista();

        txtNombre.focus();
    }

    private void verPeriodo(MotivoDevolucaoBilhete mc) {
        if (mc == null) {
            return;
        }

        Map args = new HashMap();
        args.put("motivoDevolucaoBilhete", mc);
        args.put("motivoDevolucaoBilheteList", motivoDevolucaoBilheteList);

        openWindow("/gui/configuraciones_comerciales/editarMotivoDevolucaoBilhete.zul",
                Labels.getLabel("editarMotivoDevolucaoBilheteController.window.title"), args, MODAL);
    }

    private void refreshLista() {
        HibernateSearchObject<MotivoDevolucaoBilhete> claseServicioBusqueda =
                new HibernateSearchObject<MotivoDevolucaoBilhete>(MotivoDevolucaoBilhete.class, pagingMotivoDevolucaoBilhete.getPageSize());

        claseServicioBusqueda.addFilterLike("descmotivo", "%" + txtNombre.getText().trim().concat("%"));
        claseServicioBusqueda.addFilterEqual("activo", true);
        claseServicioBusqueda.addSortAsc("descmotivo");

        plwMotivoDevolucaoBilhete.init(claseServicioBusqueda, motivoDevolucaoBilheteList, pagingMotivoDevolucaoBilhete);

        if (motivoDevolucaoBilheteList.getData().length == 0) {
            try {
                Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
                        Labels.getLabel("busquedaMotivoDevolucaoBilheteController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);
            } catch (InterruptedException ex) {
            }
        }
    }
}
